#version 330
#pragma optionNV unroll all

in vec3 position;
in vec3 normal;
in vec2 uv;

uniform mat4 modelMatrix;
uniform mat4 MVPMatrix;
uniform mat4 normalMatrix;
uniform mat4 lightMVPMatrix;

//#define MAX_ASTEROID_MVPS 20
//uniform mat4 asteroidMVPs[MAX_ASTEROID_MVPS];

out vec4 positionFrag;
out vec4 normalFrag;
out vec2 uvFrag;

// coordinates in the ShadowMap
out vec4 SM_tex_coord;

void main() {
	
	positionFrag = modelMatrix * vec4(position, 1.0);
	normalFrag = vec4(normalize(mat3(normalMatrix) * normal), 0.0);
	uvFrag = uv;

	SM_tex_coord = lightMVPMatrix * vec4(position, 1.0);
	
	gl_Position = MVPMatrix * vec4(position, 1.0);
	
}